add_library('serial')

ct = 0.0
sw = 0
ry = 0
    
def setup():
    # size(1280, 720, P3D)
    fullScreen(P3D)
    noCursor()
    frameRate(60)
    
    global matrix
    matrix = [[random(2) for x in range(20)] for y in range(7)] 
    
    global top
    global bottom
    top = loadShape("data/top.obj")
    bottom = loadShape("data/bottom.obj")
        
    #setup the serial port
    portIndex = len(Serial.list()) - 1
    LF = 10
    
    print " Connecting to ", Serial.list()[portIndex]
    
    myPort = Serial(this, Serial.list()[portIndex], 9600)
    myPort.bufferUntil(LF)

    
def draw():
    global ry
    smooth()
    background(255 - sw)
    if sw == 0:
        # lights()
        directionalLight(102, 102, 102, 0, 0, -1)
        lightSpecular(204, 204, 204)
        directionalLight(102, 102, 102, 0, 1, -1)
        lightSpecular(102, 102, 102)
    else:
        directionalLight(random(255), random(255), random(255), 0, 0, -1)
        lightSpecular(random(255), random(255), random(255))
        directionalLight(random(255), random(255), random(255), 0, 1, -1)
        lightSpecular(random(255), random(255), random(255))
        
    for i in range(10):
        pushMatrix()
        
        for j in range(7):
            pushMatrix()
            
            translate(width / 2 - 9 + ((i - 3) * 16), height/2 -6 + ((j - 3) * 12), 555)

            if sw:
                translate(-16,0,random(50) - 25)
                            
                if matrix[j][i] > 1:
                    rotateY(ry * -(i + j + 1))
                    specular(random(255), random(255), random(255))
                    shape(bottom)
                else:
                    rotateY(ry * -(i + j + 1))
                    specular(random(255), random(255), random(255))
                    shape(top)
            else:    
                rotateY(ry * (i + j + 1))
                shape(top)
            
            popMatrix()
        popMatrix()

    ry += (ct * 0.01)
     
def serialEvent(evt):
    global ct
    global sw
    
    inString = evt.readString()
    splut = inString.split(":")
    
    digits = splut[1].replace(" ", "")
    digits = digits.replace("\r", "")
    digits = digits.replace("\n", "")
    
    if (splut[0] == "count"):
        ct = float(digits) * 0.1
        print(ct)
        
    elif (splut[0] == "switch"):
        sw = int(digits) * 255
        matrix = [[random(2) for x in range(20)] for y in range(7)]